#ifndef CUETRACKLISTWIDGET_H
#define CUETRACKLISTWIDGET_H
#include <QWidget>
#include <QScrollArea>
#include <QVBoxLayout>

#include "cuetrackwidget.h"

class CueTrackListWidget : public QWidget {
    Q_OBJECT
public:
    size_t size = 0;

    explicit CueTrackListWidget(QWidget *parent = nullptr) : QWidget(parent) {
        layout = new QVBoxLayout();
        containerWidget = new QWidget();
        containerWidget->setLayout(layout);

        scrollArea = new QScrollArea(this);
        scrollArea->setWidgetResizable(true);
        scrollArea->setWidget(containerWidget);

        QVBoxLayout* mainLayout = new QVBoxLayout(this);
        mainLayout->addWidget(scrollArea);
        setLayout(mainLayout);
    }

    void addCueTrackWidget(CueTrackWidget* widget) {
        layout->addWidget(widget);
        size++;
    }

    void clear() {
        QLayoutItem* item;
        while ((item = layout->takeAt(0)) != nullptr) {
            delete item->widget();
            delete item;
        }
        size = 0;
    }

	CueTrackWidget* getTrackAtIndex(size_t index) {
        if (index < this->size) {
			return qobject_cast<CueTrackWidget*>(layout->itemAt(index)->widget());
		}
		return nullptr;
	}

private:
    QScrollArea* scrollArea;
    QWidget* containerWidget;
    QVBoxLayout* layout;
};
#endif
